/*******************************************************************************

  Copyright (c) Odin TeleSystems Inc., 2004, All Rights Reserved.

  Odin TeleSystems Inc.

  OTX Telecom Adapter Driver

  @doc PublicDemo

  @module

    OtxBurstStatsDlg.cpp

    A simple example Windows application demonstrating the use of OTX
    Driver with the Plus cards.

    The sample application provides a simple windows gui interface which
    demostrates one of the many ways to implement a windows application.
    This demo is a simple Microsoft MFC dialog based application that
    presents a list of Burst capable devices that are found in the machine
    and displays the Burst statistics.

*******************************************************************************/

// OtxBurstStatsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "OtxBurstStats.h"
#include "OtxBurstStatsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COtxBurstStatsDlg dialog

COtxBurstStatsDlg::COtxBurstStatsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COtxBurstStatsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COtxBurstStatsDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void COtxBurstStatsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COtxBurstStatsDlg)
	DDX_Control(pDX, IDC_LIST1, m_List1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(COtxBurstStatsDlg, CDialog)
	//{{AFX_MSG_MAP(COtxBurstStatsDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COtxBurstStatsDlg message handlers

BOOL COtxBurstStatsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

  OTX_RESULT OtxResult;
  OTX_UINT32 ui32Return;

  OtxResult = OtxDrvGetAttributeValue(OTX_LIB_HANDLE, OTX_ATTR_LIB_REV_NUM, &m_sApiVersionInfo, sizeof(m_sApiVersionInfo), &ui32Return);
  if (OtxResult != OTX_S_OK) {
    AfxMessageBox("OTX Error: Unable to get OTX SDK Version Information!", MB_OK | MB_ICONERROR);
    return TRUE;
  }

  OtxResult = OtxDrvGetAttributeValueSz(OTX_LIB_HANDLE, OTX_ATTR_LIB_REV_STR, m_szApiVersionStr, sizeof(m_szApiVersionStr));
  if (OtxResult != OTX_S_OK) {
    AfxMessageBox("OTX Error: Unable to get OTX API Version String!", MB_OK | MB_ICONERROR);
    return TRUE;
  }


  m_List1.SetExtendedStyle(LVS_EX_GRIDLINES|LVS_EX_FULLROWSELECT);

  m_List1.InsertItem(ROW_STARTS                 , "Starts");
  m_List1.InsertItem(ROW_COMPLETES              , "Completes");
  m_List1.InsertItem(ROW_PARTIAL                , "Partial");
  m_List1.InsertItem(ROW_FULL                   , "Full");
  m_List1.InsertItem(ROW_ABORTS                 , "Aborts");
  m_List1.InsertItem(ROW_AMOUNT                 , "Amount");
  m_List1.InsertItem(ROW_ERRORS                 , "Errors");
  m_List1.InsertItem(ROW_OURUNS                 , "[Over/Under]runs");
  m_List1.InsertItem(ROW_OURUNS_USER            , "User [O/U]runs");
  m_List1.InsertItem(ROW_DMABUSY                , "DMA Busy");
  m_List1.InsertItem(ROW_NOTIFY                 , "Notify");
  m_List1.InsertItem(ROW_NOTIFY_PARTIAL         , "Notify Partial");

  if ((   (m_sApiVersionInfo.nMjRev == 1)
      &&  (m_sApiVersionInfo.nMnRev == 0)
      &&  (m_sApiVersionInfo.nPrelLevel >= 151))
      ||
    (     (m_sApiVersionInfo.nMjRev >= 2) 
      &&  (m_sApiVersionInfo.nMnRev >= 4))
      )

  {
    // these were supported starting w/ 1.0-P151
    m_List1.InsertItem(ROW_FIFO_SIZE              , "Fifo Size");
    m_List1.InsertItem(ROW_FIFO_TRIGGER           , "Fifo Trigger");
    m_List1.InsertItem(ROW_FIFO_COUNT             , "Fifo Count");
    m_List1.InsertItem(ROW_FIFO_PEAK              , "Fifo Peak");
    m_List1.InsertItem(ROW_FIFO_TRIGGER_COUNT     , "Fifo Trigger Count");
  }

  if ((   (m_sApiVersionInfo.nMjRev >= 2) 
      &&  (m_sApiVersionInfo.nMnRev >= 4))
      )
  {
    m_List1.InsertItem(ROW_CODE_ERRORS          , "Code Errors");
    m_List1.InsertItem(ROW_RESERVED0            , "Reserved0");
    m_List1.InsertItem(ROW_RESERVED1            , "Reserved1");
    m_List1.InsertItem(ROW_RESERVED2            , "Reserved2");
    m_List1.InsertItem(ROW_RESERVED3            , "Reserved3");
    m_List1.InsertItem(ROW_RESERVED4            , "Reserved4");
    m_List1.InsertItem(ROW_RESERVED5            , "Reserved5");
    m_List1.InsertItem(ROW_RESERVED6            , "Reserved6");
    m_List1.InsertItem(ROW_RESERVED7            , "Reserved7");
  }


  RECT rect;
  m_List1.GetClientRect(&rect);
  m_List1.InsertColumn(COL_PROPERTY, "Property", LVCFMT_LEFT, (rect.right - rect.left) - 202, COL_PROPERTY);
  m_List1.InsertColumn(COL_SEND, "Transmit", LVCFMT_RIGHT, 100, COL_SEND);
  m_List1.InsertColumn(COL_RECV, "Receive", LVCFMT_RIGHT, 100, COL_RECV);

  hBurst = OTX_INVALID_HANDLE_VALUE;

  OtxResult = OtxDrvConnectLib();
  if (OtxResult != OTX_S_OK) {
    switch (OTX_RESULT_CODE(OtxResult)) {
    case OTX_RES_HANDLE:
      AfxMessageBox("Error: Could not connect to the OTX library.\nPossible cause: OTX Driver not loaded\n", MB_OK | MB_ICONERROR);
      OtxDrvReleaseLib();
      break;
    case OTX_RES_NOT_SUPPORTED:
      AfxMessageBox("Error: Mismatch between OTX Driver revision and OTX Library revision.\nRevisions must match.", MB_OK | MB_ICONERROR);
      break;
    default:
      ReportError(OTX_INVALID_HANDLE_VALUE, OtxResult);
      break;
    }

    return TRUE;
  }

  // Query driver revision
  {
    OtxResult = OtxDrvGetAttributeValueSz(OTX_DRIVER_DEVICE_HANDLE, OTX_ATTR_DRV_REV_STR, m_szDriverVersionStr, sizeof(m_szDriverVersionStr)); 
    if (OtxResult != OTX_S_OK) {
      AfxMessageBox("OTX Error: Unable to get OTX Driver Version String!", MB_OK | MB_ICONERROR);
      return TRUE;
    }
  }


  Fill_cbOtxDevices();

  SetTimer(1, 1000, NULL);
  
  return TRUE;  // return TRUE  unless you set the focus to a control
}

void COtxBurstStatsDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void COtxBurstStatsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR COtxBurstStatsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void COtxBurstStatsDlg::FormatTimeStamp(OTX_DATETIME nTimeStamp, CString &s)
{
  OTX_DATETIME nTimeStampMs;
  OTX_DATETIME nTimeStampSec;
  struct Osa_tm *ptCurrentDayAndTime;
  Osa_time_t nCurrentTimeSecs;

  // Subtract number of 100ns ticks between Jan 1, 1970 and Jan 1, 1600
  nTimeStamp.nUint64 = nTimeStamp.nUint64 - 116444736000000000;

  // Convert to seconds since Jan 1, 1970 (so we can use this time with OsaStdLocalTime())
  nTimeStampSec.nUint64 = nTimeStamp.nUint64 / 10000000;

  // Calculate number of milliseconds (since number of seconds is not a very accurate way to report timestamp)
  nTimeStampMs.nUint64 = nTimeStamp.nUint64 / 10000 - (nTimeStampSec.nUint64 * 1000);

  nCurrentTimeSecs = nTimeStampSec.sUint32.nLow;
  ptCurrentDayAndTime = OsaStdLocalTime(&nCurrentTimeSecs);

  if (ptCurrentDayAndTime) {
    s.Format("%.2d-%.2d %.2d:%.2d:%.2d.%.3d",
      ptCurrentDayAndTime->tm_mon + 1,
      ptCurrentDayAndTime->tm_mday,
      ptCurrentDayAndTime->tm_hour,
      ptCurrentDayAndTime->tm_min,
      ptCurrentDayAndTime->tm_sec,
      nTimeStampMs.sUint32.nLow
    );
  } else {
    s.Format("Error: Invalid timestamp (before Jan 1, 1970)");
  }
}

void COtxBurstStatsDlg::OnTimer(UINT nIDEvent) 
{
  OTX_UINT32        stat_Starts;          // Number of actual dma transfers initiated
  OTX_UINT32        stat_Completes;       // Number of actual dma transfers completed
  OTX_UINT32        stat_Partial;         // Number of partial transfer due to framemask
  OTX_UINT32        stat_Full;            // Number of count of max dma size transfers
  OTX_UINT32        stat_Aborts;          // Number of actual dma transfers aborts
  OTX_UINT32        stat_Amount;          // Number of amount of data transfered
  OTX_UINT32        stat_Errors;          // Number of count of processing errors
  OTX_UINT32        stat_OUruns;          // Number of amount of over/under runs
  OTX_UINT32        stat_OUrunsUser;      // Number of amount of over/under runs caused by user mode
  OTX_UINT32        stat_DmaBusy;         // Number of count of DMA busy occurances
  OTX_UINT32        stat_Notify;          // Number of logical device notifies
  OTX_UINT32        stat_NotifyPartial;   // Number of logical device notifies - partial
  OTX_UINT32        stat_FifoSize;
  OTX_UINT32        stat_FifoTrigger;
  OTX_UINT32        stat_FifoCount;
  OTX_UINT32        stat_FifoPeak;
  OTX_UINT32        stat_FifoTriggerCount;
  OTX_UINT32        stat_CodeErrors;
  OTX_UINT32        stat_Reserved0;
  OTX_UINT32        stat_Reserved1;
  OTX_UINT32        stat_Reserved2;
  OTX_UINT32        stat_Reserved3;
  OTX_UINT32        stat_Reserved4;
  OTX_UINT32        stat_Reserved5;
  OTX_UINT32        stat_Reserved6;
  OTX_UINT32        stat_Reserved7;

  OTX_UINT32                ui32;
  OtxBurstFrameRefAndTime   FrameRef;             // frame reference data
  static OTX_UINT64         nLastFrame = 0;
  
  CString s;

  if (hBurst == OTX_INVALID_HANDLE_VALUE) {
    return;
  }

  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_STARTS,            &stat_Starts            );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_COMPLETES,         &stat_Completes         );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_PARTIAL,           &stat_Partial           );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_FULL,              &stat_Full              );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_ABORTS,            &stat_Aborts            );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_AMOUNT,            &stat_Amount            );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_ERRORS,            &stat_Errors            );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_OURUNS,            &stat_OUruns            );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_OURUNS_USER,       &stat_OUrunsUser        );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_DMABUSY,           &stat_DmaBusy           );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_NOTIFY,            &stat_Notify            );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_NOTIFY_PARTIAL,    &stat_NotifyPartial     );

  if ((   (m_sApiVersionInfo.nMjRev == 1)
      &&  (m_sApiVersionInfo.nMnRev == 0)
      &&  (m_sApiVersionInfo.nPrelLevel >= 151))
      ||
    (     (m_sApiVersionInfo.nMjRev >= 2) 
      &&  (m_sApiVersionInfo.nMnRev >= 4))
      )

  {
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_RECEIVER_FIFO_SIZE,          &stat_FifoSize          );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_RECEIVER_FIFO_TRIGGER,       &stat_FifoTrigger       );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_RECEIVER_FIFO_COUNT,         &stat_FifoCount         );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_RECEIVER_FIFO_PEAK,          &stat_FifoPeak          );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_RECEIVER_FIFO_TRIGGER_COUNT, &stat_FifoTriggerCount  );
  }

  if ((   (m_sApiVersionInfo.nMjRev >= 2) 
      &&  (m_sApiVersionInfo.nMnRev >= 4))
      )
  {
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_CODE_ERRORS,       &stat_CodeErrors        );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_RESERVED0,         &stat_Reserved0         );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_RESERVED1,         &stat_Reserved1         );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_RESERVED2,         &stat_Reserved2         );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_RESERVED3,         &stat_Reserved3         );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_RESERVED4,         &stat_Reserved4         );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_RESERVED5,         &stat_Reserved5         );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_RESERVED6,         &stat_Reserved6         );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_RESERVED7,         &stat_Reserved7         );
  }


  s.Format("%u", stat_Starts            ); m_List1.SetItemText(ROW_STARTS                 , COL_RECV, s);
  s.Format("%u", stat_Completes         ); m_List1.SetItemText(ROW_COMPLETES              , COL_RECV, s);
  s.Format("%u", stat_Partial           ); m_List1.SetItemText(ROW_PARTIAL                , COL_RECV, s);
  s.Format("%u", stat_Full              ); m_List1.SetItemText(ROW_FULL                   , COL_RECV, s);
  s.Format("%u", stat_Aborts            ); m_List1.SetItemText(ROW_ABORTS                 , COL_RECV, s);
  s.Format("%u", stat_Amount            ); m_List1.SetItemText(ROW_AMOUNT                 , COL_RECV, s);
  s.Format("%u", stat_Errors            ); m_List1.SetItemText(ROW_ERRORS                 , COL_RECV, s);
  s.Format("%u", stat_OUruns            ); m_List1.SetItemText(ROW_OURUNS                 , COL_RECV, s);
  s.Format("%u", stat_OUrunsUser        ); m_List1.SetItemText(ROW_OURUNS_USER            , COL_RECV, s);
  s.Format("%u", stat_DmaBusy           ); m_List1.SetItemText(ROW_DMABUSY                , COL_RECV, s);
  s.Format("%u", stat_Notify            ); m_List1.SetItemText(ROW_NOTIFY                 , COL_RECV, s);
  s.Format("%u", stat_NotifyPartial     ); m_List1.SetItemText(ROW_NOTIFY_PARTIAL         , COL_RECV, s);

  if ((   (m_sApiVersionInfo.nMjRev == 1)
      &&  (m_sApiVersionInfo.nMnRev == 0)
      &&  (m_sApiVersionInfo.nPrelLevel >= 151))
      ||
    (     (m_sApiVersionInfo.nMjRev >= 2) 
      &&  (m_sApiVersionInfo.nMnRev >= 4))
      )

  {
    s.Format("%u", stat_FifoSize          ); m_List1.SetItemText(ROW_FIFO_SIZE              , COL_RECV, s);
    s.Format("%u", stat_FifoTrigger       ); m_List1.SetItemText(ROW_FIFO_TRIGGER           , COL_RECV, s);
    s.Format("%u", stat_FifoCount         ); m_List1.SetItemText(ROW_FIFO_COUNT             , COL_RECV, s);
    s.Format("%u", stat_FifoPeak          ); m_List1.SetItemText(ROW_FIFO_PEAK              , COL_RECV, s);
    s.Format("%u", stat_FifoTriggerCount  ); m_List1.SetItemText(ROW_FIFO_TRIGGER_COUNT     , COL_RECV, s);
  }


  if ((   (m_sApiVersionInfo.nMjRev >= 2) 
      &&  (m_sApiVersionInfo.nMnRev >= 4))
      )
  {
    s.Format("%u", stat_CodeErrors      ); m_List1.SetItemText(ROW_CODE_ERRORS              , COL_RECV, s);
    s.Format("%u", stat_Reserved0       ); m_List1.SetItemText(ROW_RESERVED0                , COL_RECV, s);
    s.Format("%u", stat_Reserved1       ); m_List1.SetItemText(ROW_RESERVED1                , COL_RECV, s);
    s.Format("%u", stat_Reserved2       ); m_List1.SetItemText(ROW_RESERVED2                , COL_RECV, s);
    s.Format("%u", stat_Reserved3       ); m_List1.SetItemText(ROW_RESERVED3                , COL_RECV, s);
    s.Format("%u", stat_Reserved4       ); m_List1.SetItemText(ROW_RESERVED4                , COL_RECV, s);
    s.Format("%u", stat_Reserved5       ); m_List1.SetItemText(ROW_RESERVED5                , COL_RECV, s);
    s.Format("%u", stat_Reserved6       ); m_List1.SetItemText(ROW_RESERVED6                , COL_RECV, s);
    s.Format("%u", stat_Reserved7       ); m_List1.SetItemText(ROW_RESERVED7                , COL_RECV, s);
  }



  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_STARTS,            &stat_Starts             );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_COMPLETES,         &stat_Completes          );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_PARTIAL,           &stat_Partial            );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_FULL,              &stat_Full               );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_ABORTS,            &stat_Aborts             );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_AMOUNT,            &stat_Amount             );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_ERRORS,            &stat_Errors             );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_OURUNS,            &stat_OUruns             );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_OURUNS_USER,       &stat_OUrunsUser         );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_DMABUSY,           &stat_DmaBusy            );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_NOTIFY,            &stat_Notify             );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_NOTIFY_PARTIAL,    &stat_NotifyPartial      );


  if ((   (m_sApiVersionInfo.nMjRev == 1)
    &&  (m_sApiVersionInfo.nMnRev == 0)
    &&  (m_sApiVersionInfo.nPrelLevel >= 151))
    ||
    (     (m_sApiVersionInfo.nMjRev >= 2) 
    &&  (m_sApiVersionInfo.nMnRev >= 4))
    )
    
  {
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_SENDER_FIFO_SIZE,            &stat_FifoSize          );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_SENDER_FIFO_TRIGGER,         &stat_FifoTrigger       );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_SENDER_FIFO_COUNT,           &stat_FifoCount         );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_SENDER_FIFO_PEAK,            &stat_FifoPeak          );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_SENDER_FIFO_TRIGGER_COUNT,   &stat_FifoTriggerCount  );
  }

  if ((   (m_sApiVersionInfo.nMjRev >= 2) 
      &&  (m_sApiVersionInfo.nMnRev >= 4))
      )
  {
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_CODE_ERRORS,       &stat_CodeErrors        );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_RESERVED0,         &stat_Reserved0         );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_RESERVED1,         &stat_Reserved1         );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_RESERVED2,         &stat_Reserved2         );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_RESERVED3,         &stat_Reserved3         );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_RESERVED4,         &stat_Reserved4         );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_RESERVED5,         &stat_Reserved5         );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_RESERVED6,         &stat_Reserved6         );
    OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_RESERVED7,         &stat_Reserved7         );
  }


  s.Format("%u", stat_Starts            ); m_List1.SetItemText(ROW_STARTS                 , COL_SEND, s);
  s.Format("%u", stat_Completes         ); m_List1.SetItemText(ROW_COMPLETES              , COL_SEND, s);
  s.Format("%u", stat_Partial           ); m_List1.SetItemText(ROW_PARTIAL                , COL_SEND, s);
  s.Format("%u", stat_Full              ); m_List1.SetItemText(ROW_FULL                   , COL_SEND, s);
  s.Format("%u", stat_Aborts            ); m_List1.SetItemText(ROW_ABORTS                 , COL_SEND, s);
  s.Format("%u", stat_Amount            ); m_List1.SetItemText(ROW_AMOUNT                 , COL_SEND, s);
  s.Format("%u", stat_Errors            ); m_List1.SetItemText(ROW_ERRORS                 , COL_SEND, s);
  s.Format("%u", stat_OUruns            ); m_List1.SetItemText(ROW_OURUNS                 , COL_SEND, s);
  s.Format("%u", stat_OUrunsUser        ); m_List1.SetItemText(ROW_OURUNS_USER            , COL_SEND, s);
  s.Format("%u", stat_DmaBusy           ); m_List1.SetItemText(ROW_DMABUSY                , COL_SEND, s);
  s.Format("%u", stat_Notify            ); m_List1.SetItemText(ROW_NOTIFY                 , COL_SEND, s);
  s.Format("%u", stat_NotifyPartial     ); m_List1.SetItemText(ROW_NOTIFY_PARTIAL         , COL_SEND, s);

  if ((   (m_sApiVersionInfo.nMjRev == 1)
    &&  (m_sApiVersionInfo.nMnRev == 0)
    &&  (m_sApiVersionInfo.nPrelLevel >= 151))
    ||
    (     (m_sApiVersionInfo.nMjRev >= 2) 
    &&  (m_sApiVersionInfo.nMnRev >= 4))
    )
    
  {
    s.Format("%u", stat_FifoSize          ); m_List1.SetItemText(ROW_FIFO_SIZE              , COL_SEND, s);
    s.Format("%u", stat_FifoTrigger       ); m_List1.SetItemText(ROW_FIFO_TRIGGER           , COL_SEND, s);
    s.Format("%u", stat_FifoCount         ); m_List1.SetItemText(ROW_FIFO_COUNT             , COL_SEND, s);
    s.Format("%u", stat_FifoPeak          ); m_List1.SetItemText(ROW_FIFO_PEAK              , COL_SEND, s);
    s.Format("%u", stat_FifoTriggerCount  ); m_List1.SetItemText(ROW_FIFO_TRIGGER_COUNT     , COL_SEND, s);
  }

  if ((   (m_sApiVersionInfo.nMjRev >= 2) 
      &&  (m_sApiVersionInfo.nMnRev >= 4))
      )
  {
    s.Format("%u", stat_CodeErrors      ); m_List1.SetItemText(ROW_CODE_ERRORS              , COL_SEND, s);
    s.Format("%u", stat_Reserved0       ); m_List1.SetItemText(ROW_RESERVED0                , COL_SEND, s);
    s.Format("%u", stat_Reserved1       ); m_List1.SetItemText(ROW_RESERVED1                , COL_SEND, s);
    s.Format("%u", stat_Reserved2       ); m_List1.SetItemText(ROW_RESERVED2                , COL_SEND, s);
    s.Format("%u", stat_Reserved3       ); m_List1.SetItemText(ROW_RESERVED3                , COL_SEND, s);
    s.Format("%u", stat_Reserved4       ); m_List1.SetItemText(ROW_RESERVED4                , COL_SEND, s);
    s.Format("%u", stat_Reserved5       ); m_List1.SetItemText(ROW_RESERVED5                , COL_SEND, s);
    s.Format("%u", stat_Reserved6       ); m_List1.SetItemText(ROW_RESERVED6                , COL_SEND, s);
    s.Format("%u", stat_Reserved7       ); m_List1.SetItemText(ROW_RESERVED7                , COL_SEND, s);
  }

  OTX_DATETIME dt;
  OtxDrvGetCurrentTime(&dt);
  FormatTimeStamp(dt, s); GetDlgItem(IDC_EDIT39)->SetWindowText(s);

  OtxDrvGetAttributeValue(hBurst, OTX_ATTR_BURST_GET_FRAME_REF_DATA, &FrameRef, sizeof(FrameRef), &ui32);
  // just skip if we wrapped
  if (FrameRef.m_FrameCounter > nLastFrame) {
    FormatTimeStamp(FrameRef.m_FrameDateTime, s); GetDlgItem(IDC_EDIT37)->SetWindowText(s);
    s.Format("%08x%08x", (OTX_UINT32) (FrameRef.m_FrameCounter >> 32), (OTX_UINT32) (FrameRef.m_FrameCounter)); GetDlgItem(IDC_EDIT38)->SetWindowText(s);
  }
  nLastFrame = FrameRef.m_FrameCounter;


  s.Format("%s", m_szApiVersionStr);
  GetDlgItem(IDC_EDIT1)->SetWindowText(s);

  s.Format("%s", m_szDriverVersionStr);
  GetDlgItem(IDC_EDIT2)->SetWindowText(s);

}

void COtxBurstStatsDlg::Fill_cbOtxDevices()
{
  OTX_RESULT OtxResult;
  OTX_ITERATOR itrChildTypes, itrChildrenOfSameType;
  OTX_INT32  hParentDevice;
  OTX_UINT32 hChildDevice;
  OtxPhysicalDeviceTypeE eDevType;
    
  CComboBox *cbOtxDevices;

  cbOtxDevices = (CComboBox *) GetDlgItem(IDC_COMBO1);
  cbOtxDevices->ResetContent();
    
  hParentDevice = 0;

  OtxDrvIteratorBegin(&itrChildTypes);
  while (OtxDrvEnumDeviceType(hParentDevice, &itrChildTypes, (OTX_INT32 *) &eDevType) == OTX_S_OK) {
    CString sDevNo, sDevType;
    OTX_UINT32 nDevNo;
      
    OtxDrvIteratorBegin(&itrChildrenOfSameType);
    while (OtxDrvEnumDevice(hParentDevice, eDevType, &itrChildrenOfSameType, &hChildDevice) == OTX_S_OK) {
      if (hChildDevice != OTX_INVALID_HANDLE_VALUE) {
        int nIndex;

        OtxResult = OtxDrvGetAttributeValueUint32(hChildDevice, OTX_ATTR_DEVICE_NO, &nDevNo);
        if (! OTX_SUCCESS(OtxResult)) {
          nDevNo = -1;
        }

        sDevNo.Format("[%d]", nDevNo);
        sDevType.Format("(%d)", eDevType);

        switch (eDevType) {
        case OTX_DEVICE_ARNI_6X6_PCI:
          nIndex = cbOtxDevices->AddString(sDevNo + " ARNI_6X6_PCI " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_ARNI_6X6_PCI_PLUS:
          nIndex = cbOtxDevices->AddString(sDevNo + " ARNI_6X6_PCI_PLUS " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_ARNI_6_FXS_PCI_PLUS:
          nIndex = cbOtxDevices->AddString(sDevNo + " ARNI_6_FXS_PCI_PLUS " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_ARNI_6_FXO_PCI_PLUS:
          nIndex = cbOtxDevices->AddString(sDevNo + " ARNI_6_FXO_PCI_PLUS " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_ARNI_6X3_PCI_PLUS:
          nIndex = cbOtxDevices->AddString(sDevNo + " ARNI_6X3_PCI_PLUS " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_GIMLE_16_PCI_PLUS:
          nIndex = cbOtxDevices->AddString(sDevNo + " GIMLE_16_PCI_PLUS " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_GIMLE_16_PCIE:
          nIndex = cbOtxDevices->AddString(sDevNo + " GIMLE_16_PCIE " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_GIMLE_16_PCI_BASIC_32:
          nIndex = cbOtxDevices->AddString(sDevNo + " GIMLE_16_PCI_BASIC_32 " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_GIMLE_16_PCI_BASIC_64:
          nIndex = cbOtxDevices->AddString(sDevNo + " GIMLE_16_PCI_BASIC_64 " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_THOR_8_PCI_PLUS:
          nIndex = cbOtxDevices->AddString(sDevNo + " THOR_8_PCI_PLUS " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_THOR_2_PCI_PLUS:
          nIndex = cbOtxDevices->AddString(sDevNo + " THOR_2_PCI_PLUS " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_THOR_4_PCI_PLUS:
          nIndex = cbOtxDevices->AddString(sDevNo + " THOR_4_PCI_PLUS " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_SLEIPNIR_1_PCI:
          nIndex = cbOtxDevices->AddString(sDevNo + " SLEIPNIR_1_PCI " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_HUGIN_2_PC104:
          nIndex = cbOtxDevices->AddString(sDevNo + " HUGIN_2_PC104 " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_THOR_1_PCI_EXPRESS:
          nIndex = cbOtxDevices->AddString(sDevNo + " THOR_1_PCI_EXPRESS " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_THOR_2_PCI_EXPRESS:
          nIndex = cbOtxDevices->AddString(sDevNo + " THOR_2_PCI_EXPRESS " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_THOR_2_EXPRESSCARD:
          nIndex = cbOtxDevices->AddString(sDevNo + " THOR_2_EXPRESSCARD " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_THOR_4_EXPRESSCARD:
          nIndex = cbOtxDevices->AddString(sDevNo + " THOR_4_EXPRESSCARD " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_ALVIS_PCI_EXPRESS:
          nIndex = cbOtxDevices->AddString(sDevNo + " ALVIS_PCI_EXPRESS " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_GODAR_1_PCI_EXPRESS:
          nIndex = cbOtxDevices->AddString(sDevNo + " GODAR_1_PCI_EXPRESS " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_GODAR_2_PCI_EXPRESS:
          nIndex = cbOtxDevices->AddString(sDevNo + " GODAR_2_PCI_EXPRESS " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        default:
          break;
        }
      }
    }
  }
    
  if (cbOtxDevices->GetCount() > 0) {
    cbOtxDevices->SetCurSel(0);
    OnSelchangeCombo1() ;
  }

}

void COtxBurstStatsDlg::OnSelchangeCombo1() 
{
  OTX_INT32 nDevNo, nDevType;

  CString sDevNo, sDevType;
    
  CComboBox *cbOtxDevices;
  int nSelect;

  cbOtxDevices = (CComboBox *) GetDlgItem(IDC_COMBO1);

  nSelect = cbOtxDevices->GetCurSel();
  if (nSelect != CB_ERR) {
    CString s;

    cbOtxDevices->GetLBText(nSelect, s);

    sDevNo    = s.Mid(s.Find("[") + 1, s.Find("]") - 1);
    sDevType  = s.Mid(s.Find("(") + 1, s.Find(")") - 1);
    nDevNo    = atoi(sDevNo);
    nDevType  = atoi(sDevType);
    
    OTX_ITERATOR itrChildrenOfSameType;
    OTX_INT32  hParentDevice;
    OTX_UINT32 hChildDevice;
    OtxPhysicalDeviceTypeE eDevType;

    hBurst = OTX_INVALID_HANDLE_VALUE;

    eDevType = OTX_DEVICE_BURST;
    hParentDevice = (long) cbOtxDevices->GetItemData(nSelect);
    OtxDrvIteratorBegin(&itrChildrenOfSameType);
    while (OtxDrvEnumDevice(hParentDevice, eDevType, &itrChildrenOfSameType, &hChildDevice) == OTX_S_OK) {
      if (hChildDevice != OTX_INVALID_HANDLE_VALUE) {
        hBurst = hChildDevice;
        break;
      }
    }

    OTX_RESULT OtxResult;
    char szSerialNoStr[128];
    char szBuildNoStr[64];
    char szFirmwareStr[128];

    OtxResult = OtxDrvGetAttributeValueSz(hParentDevice, OTX_ATTR_BRD_SERIAL_NUMBER, szSerialNoStr, sizeof(szSerialNoStr));
    if (OtxResult != OTX_S_OK) {
      AfxMessageBox("OTX Error: Unable to get Board Serial Number String!", MB_OK | MB_ICONERROR);
      return;
    }

    OtxResult = OtxDrvGetAttributeValueSz(hParentDevice, OTX_ATTR_BRD_BUILD, szBuildNoStr, sizeof(szBuildNoStr));
    if (OtxResult != OTX_S_OK) {
      AfxMessageBox("OTX Error: Unable to get Board Build Number String!", MB_OK | MB_ICONERROR);
      return;
    }

    s.Format("%s", szSerialNoStr);
    GetDlgItem(IDC_EDIT3)->SetWindowText(s);

    s.Format("%s", szBuildNoStr);
    GetDlgItem(IDC_EDIT4)->SetWindowText(s);

    OtxResult = OtxDrvGetAttributeValueSz(hParentDevice, OTX_ATTR_BRD_CPLD_BUILD, szFirmwareStr, sizeof(szFirmwareStr));
    if (OtxResult == OTX_S_OK) {
      s.Format("%s", szFirmwareStr);
      s.Replace("\n", "\r\n");
    } else {
      s.Format("%s", "N/A");
    }
    GetDlgItem(IDC_EDIT5)->SetWindowText(s);

  }
}

void COtxBurstStatsDlg::ReportError(OTX_HANDLE hDev, OTX_RESULT resErr)
{
  CString str;

  if (OtxDrvResultCode2String(hDev, resErr, 256, str.GetBuffer(256)) != OTX_S_OK) {
    str = "Unknown Error!";
  }
  str.Format("%s\n(ref: 0x%x [%d.%d])", str, OTX_RESULT_CODE(resErr), OTX_RESULT_SOURCE_ID(resErr), OTX_RESULT_LINE_NUM(resErr));
  str.ReleaseBuffer();

  AfxMessageBox(str, MB_OK | MB_ICONERROR);
}


void COtxBurstStatsDlg::OnClose() 
{
  OtxDrvReleaseLib();
	
	CDialog::OnClose();
}

void COtxBurstStatsDlg::OnButton1() 
{
  if (hBurst != OTX_INVALID_HANDLE_VALUE) {
    OtxDrvDbgDump(hBurst, 101);   // reset stats
  }
}

void COtxBurstStatsDlg::OnButton2() 
{
  if (hBurst != OTX_INVALID_HANDLE_VALUE) {
    OtxDrvDbgDump(hBurst, 100);   // Dump stats to debugger
  }
}
