/* $Workfile: OtxDrvD.h $   $Revision: 4 $    $Modtime: 11/05/09 10:53a $  */
#ifndef OTX_DRV_DEF_H
#define OTX_DRV_DEF_H
/*******************************************************************************

  @doc PublicHwApi OtxDrvD

  Copyright (C) 2000 - 2008 Odin TeleSystems Inc., All Rights Reserved

  OTX Generic Hardware Driver API

  @module
  OtxDrvD | Constants, Macros, and Types for the Driver Functions

  @contents2
  OtxDrvD.h |

  @index const enum struct type | OtxDrvD

  @contents2
  OTX Driver Management Macros, Constants, and Types |

  @head3 Enumerated Types  |

  @index enum | OtxDrvD

  @head3 Struct Types |

  @index struct | OtxDrvD

  @head3 Constants |

  @index const | OtxDrvD

  @head3 Other Types |

  @index type | OtxDrvD


*******************************************************************************/


#ifdef __cplusplus
extern "C" {
#endif

#include "OtxType.h"

/******************************************************************************
  @enum
    Computer Telephony Bus (H.100) highway data rates
******************************************************************************/
enum OtxCtBusDataRateE {
  OTX_CT_BUS_DATA_RATE_2048_KBPS = 0,
  OTX_CT_BUS_DATA_RATE_4096_KBPS = 1,
  OTX_CT_BUS_DATA_RATE_8192_KBPS = 2
};

typedef enum OtxCtBusDataRateE OtxCtBusDataRateE;
/******************************************************************************
  @struct
    OtxDrvConnectLibEx initialization struct
******************************************************************************/
struct OtxDrvConnectLibExS
{
  const OTX_UINT8* szLocalIf; 
  const OTX_UINT8* szRemoteAddr;
  OTX_UINT16       nTcpPort;  
  OTX_UINT16       nUdpPort;
};
typedef struct OtxDrvConnectLibExS OtxDrvConnectLibExS;


#ifdef __cplusplus
}  // extern "C"
#endif

/*******************************************************************************

  Copyright (C) Odin TeleSystems Inc., 2000 - 2008

  All rights reserved. No part of this computer program may be reproduced,
  stored in any retrieval system, or transmitted, in any form or by any
  means, electronic, mechanical, photocopying, recording, or otherwise,
  without the prior written permission of Odin TeleSystems Inc., or without
  a permission stipulated in the agreement/contract under which this computer
  program was supplied.

*******************************************************************************/
#endif    // OTX_DRV_DEF_H
